/* rem and em do not depend html font-size in media queries! 
Instead 1rem = 1em = 16px */

/* We should use em unit in media queries */

/* ***************************** */
/* BELOW 1344px (Smaller Desktops) */
/* ***************************** */

@media (max-width: 84em) {
  .hero {
    max-width: 120rem;
  }

  .heading-primary {
    font-size: 4.4rem;
  }

  .gallery {
    grid-template-columns: repeat(2, 1fr);
  }
}

/* ***************************** */
/* BELOW 1200px (Landscape Tablets) */
/* ***************************** */

/* check for width from 1200px to 900px and fix where design breaks */

/* A media query should work 200-300px from its size */
@media (max-width: 75em) {
  html {
    /* 16px / 9px = 56.25% */
    font-size: 56.25%;
  }

  .grid {
    column-gap: 4.8rem;
    row-gap: 6.4rem;
  }

  .heading-secondary {
    font-size: 3.6rem;
  }

  .heading-tertiary {
    font-size: 2.4rem;
  }

  .header {
    padding: 0 3.2rem;
  }

  .main-nav-list {
    gap: 3.2rem;
  }

  .hero {
    gap: 4.8rem;
  }

  .testimonials-container {
    /* adding same horizontal padding as header and container */
    padding: 9.6rem 3.2rem;
  }
}
/* ***************************** */
/* BELOW 944px (Tablets) */
/* ***************************** */

/* Tablet devices width starts from 900px we are taking 944px as our design breaks there */

@media (max-width: 59em) {
  html {
    /* 16px / 8px = 50% */
    font-size: 50%;
  }

  /* add padding as content becomes wide */

  .hero {
    grid-template-columns: 1fr;
    padding: 0 8rem;
    gap: 6.4rem;
  }

  /* centering two columns of the hero section that is hero-text-box and hero-img-box, images are inline elements so they are also affected by text align center */

  .hero-text-box,
  .hero-img-box {
    text-align: center;
  }

  .hero-img {
    width: 60%;
  }

  /* center delivered meals flex-container */
  .delivered-meals {
    justify-content: center;
    margin-top: 3.2rem;
  }

  /* fixing featured in */
  .logos img {
    height: 2.4rem;
  }

  .step-number {
    font-size: 7.4rem;
  }

  .meal-content {
    padding: 2.4rem 3.2rem 3.2rem 3.2rem;
  }

  .section-testimonials {
    grid-template-columns: 1fr;
  }

  .gallery {
    grid-template-columns: repeat(6, 1fr);
  }

  .cta {
    /* grid-template-columns: 60fr 40fr; */
    grid-template-columns: 3fr 2fr;
  }

  .cta-form {
    grid-template-columns: 1fr;
  }

  .btn--form {
    margin-top: 1.2rem;
  }

  /* MOBILE NAVIGATION */

  .btn-mobile-nav {
    display: block;
    z-index: 9999;
  }

  /* The class header parent element of .main-nav is positioned relative */
  /* absolute positioning takes elements out of the flow */
  .main-nav {
    background-color: rgba(255, 255, 255, 0.9);
    /* Blur everything that is behind this element */
    /* Supported in safari using webkit prefix */
    -webkit-backdrop-filter: blur(5px);
    backdrop-filter: blur(5px);
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100vh;
    /* translating by 100% of its own width */
    transform: translateX(100%);

    display: flex;
    justify-content: center;
    align-items: center;
    /* transition:property-to-animate duration type-of-animation */
    /* By default transition type is linear */
    /* Specifying transition curve */
    /* ease-out: fast in beginnig, slows down later */
    /* ease-in: fast in later, slows down in begining */
    /* ease-in-out: fast in later, fast in begining, slows down in middle */

    transition: all 0.5s ease-in;
    /* Hide navigation */
    /* Allows no transition at all */
    /* display: none; */

    /* Way of hiding element without using display none */
    /* 1) Hide it visually */
    opacity: 0;

    /* With opacity set to 0 the links are accessible using tab */
    /* 2) Make it unaccessible to mouse and keyboard */
    pointer-events: none;

    /* 3) Hide it from screenreaders */
    visibility: hidden;
  }

  /* When there is nav-open class in header element this rule will apply */
  .nav-open .main-nav {
    opacity: 1;
    pointer-events: auto;
    visibility: visible;
    transform: translateX(0);
  }

  /* Activating close button when nav-open class is present on header */
  .nav-open .icon-mobile-nav[name="close-outline"] {
    display: block;
  }
  /* Hiding the menu-outline button on same condition */
  .nav-open .icon-mobile-nav[name="menu-outline"] {
    display: none;
  }

  .main-nav-list {
    flex-direction: column;
    gap: 4.8rem;
  }

  .main-nav-link:link,
  .main-nav-link:visited {
    font-size: 3rem;
  }
}

/* ***************************** */
/* BELOW 704px (Smaller Tablets) */
/* ***************************** */

/* Making 4/3 column grids into two column */
@media (max-width: 44em) {
  .grid--3-cols,
  .grid--4-cols {
    grid-template-columns: repeat(2, 1fr);
  }
  .diets {
    grid-column: 1 / -1;
    justify-self: center;
  }
  .heading-secondary {
    margin-bottom: 4.8rem;
  }
  /* Making width 75% to 100% */
  .pricing-plan {
    width: 100%;
  }
  .grid--footer {
    grid-template-columns: repeat(6, 1fr);
  }

  .logo-col,
  .address-col {
    /* Span can be used to fix assymetric columns */
    /* Span each grid-item across 3 columns */
    grid-column: span 3;
  }
  .nav-col {
    /* Make the footer navigation column in first row */
    grid-row: 1;
    grid-column: span 2;
    margin-bottom: 3.2rem;
  }
}

/* ***************************** */
/* BELOW 544px (Phones) */
/* ***************************** */

@media (max-width: 34em) {
  .grid {
    row-gap: 4.8rem;
  }

  .grid--2-cols,
  .grid--3-cols,
  .grid--4-cols {
    grid-template-columns: 1fr;
  }

  .section-hero {
    padding: 2.4rem 0 6.4rem 0;
  }

  .hero {
    padding: 0 3.2rem;
  }

  .btn,
  .btn:link,
  .btn:visited {
    /* In mobile devices add more height to the button */
    padding: 2.4rem 1.6rem;
  }
  /* Make the hero-img bigger */
  .hero-img {
    width: 80%;
  }

  /* Make the logos smaller */
  .logos img {
    height: 1.2rem;
  }

  /* step-img-box is the second child of the container(parent) element */
  .step-img-box:nth-child(2) {
    grid-row: 1;
  }
  .step-img-box:nth-child(6) {
    grid-row: 5;
  }
  /* Maintaining visual hierarchy making image closer to text (where it belongs) */
  .step-img-box {
    transform: translateY(2.4rem);
  }

  .testimonials {
    grid-template-columns: 1fr;
  }

  /* Making the gallery bigger */
  .gallery {
    gap: 1.2rem;
    grid-template-columns: repeat(4, 1fr);
  }

  .cta {
    grid-template-columns: 1fr;
  }

  /* reduce spacing in cta-text-box */
  .cta-text-box {
    padding: 3.2rem;
  }

  /* cta-img-box is not visible for having no height */
  .cta-img-box {
    height: 32rem;
    grid-row: 1;
  }
}

/* Keep style.css and general.css in other side of queries.css for convenience */

/* For desktop-first approach the idea is to start from biggest width decreasing the width and add breakpoints where the design breaks, vice-versa for mobile-first */

/* 
SPACING SYSTEM (px)
2 / 4 / 8 / 12 / 16 / 24 / 32 / 48 / 64 / 80 / 96 / 128 
 */

/* 
FONT SIZE SYSTEM (px)
10 / 12 / 14 / 16 / 18 / 20 / 24 / 30 / 36 / 44 / 52 / 62 / 74 / 86 / 98
*/

/* ***************************** */
/* FIXING SAFARI FLEXBOX GAP */
/* ***************************** */

.no-flexbox-gap .main-nav-list li:not(:last-child) {
  margin-right: 4.8rem;
}

.no-flexbox-gap .list-item:not(:last-child) {
  margin-bottom: 1.6rem;
}

.no-flexbox-gap .list-icon:not(:last-child) {
  margin-right: 1.6rem;
}

.no-flexbox-gap .delivered-faces {
  margin-right: 1.6rem;
}

.no-flexbox-gap .meal-attribute:not(:last-child) {
  margin-bottom: 2rem;
}

.no-flexbox-gap .meal-icon {
  margin-right: 1.6rem;
}

.no-flexbox-gap .footer-row div:not(:last-child) {
  margin-right: 6.4rem;
}

.no-flexbox-gap .social-links li:not(:last-child) {
  margin-right: 2.4rem;
}

.no-flexbox-gap .footer-nav li:not(:last-child) {
  margin-bottom: 2.4rem;
}

@media (max-width: 75em) {
  .no-flexbox-gap .main-nav-list li:not(:last-child) {
    margin-right: 3.2rem;
  }
}

@media (max-width: 59em) {
  .no-flexbox-gap .main-nav-list li:not(:last-child) {
    margin-right: 0;
    margin-bottom: 4.8rem;
  }
}
